From: Alan Jack Pippin <ajp@pippin.(none)>
Date: Mon, 13 Mar 2006 06:26:09 +0000 (-0700)
Subject: Added support for new cacheburnimg directive that will cache a burn image from the... 
X-Git-Tag: release-0.6~5
X-Git-Url: http://git.pippins.net/%27%20%20%20%20.%20%24GLOBALS%5B%27phpgw%27%5D-%3Elink%28%27inc/jquery/images/static/%27.%24link.%27?a=commitdiff_plain;h=871b0391b4520f93403a20cf6a6725f1a23b2a81;p=backups%2F.git

Added support for new cacheburnimg directive that will cache a burn image from the network to the local drive.
---

diff --git a/scripts/burn-imgs.sh b/scripts/burn-imgs.sh
index 115d58c..6f0ed55 100755
--- a/scripts/burn-imgs.sh
+++ b/scripts/burn-imgs.sh
@@ -25,6 +25,16 @@ img=${imgmd5%.md5sum}
 
 touch $noburnfile
 
+# Now check to see if we need to cache the image to a local drive before burning the image
+if [[ $cacheburnimg == 1 && -d $cacheburnimgdir ]]; then
+  rsync -av --exclude '*.mnt' $img* $cacheburnimgdir > $logfile 2>&1
+  if [ $? != 0 ]; then
+    cat $logfile | mailx -s "backups: failed to cache $img to local dir $cacheburnimgdir !!!" $mailto
+    exit 1
+  fi
+  img=$cacheburnimgdir/$(basename "$img")
+fi
+
 # A little paranoia.  Make sure the disk image file is there.
 [ -z "$img" ] && exit 1
 [ -s "$img" ] || exit 1
@@ -66,6 +76,9 @@ fi
 # Record the date in the stat file to indicate that this burn was a success
 date >> $img.stat
 
+# Update the source file stat file if we burned a cached copy of the image
+[[ $cacheburnimg == 1 && -d $cacheburnimgdir ]] && date >> ${imgmd5%.md5sum}.stat
+
 { # Send e-mail
   echo "Image md5sum:"
   cat $img.md5sum
@@ -80,7 +93,14 @@ date >> $img.stat
 
 # Two lines in the stat file indicate two successful burns.  Clean-up the image.
 if [ "$(wc -l $img.stat 2>/dev/null | awk '{print$1}')" == "$makeXcopies" ]; then
-  # Burned the image twice.  Removing it and associated files!
+  # Burned the image $makeXcopies number of times.  Removing it and associated files! 
+  if [[ $cacheburnimg == 1 && -d $cacheburnimgdir ]]; then
+    # Remove our cached copy of the image, its md5sum, and stat file
+    rm -f $img{,.md5sum,.stat}
+    # Now restore our $img variable to point back to the original source file
+    img=${imgmd5%.md5sum}
+  fi
   rm -f $img{,.md5sum,.stat}
   [ -d $img.mnt ] && rmdir $img.mnt
 fi
+
diff --git a/scripts/config.sh b/scripts/config.sh
index 22aae1a..6eb6472 100755
--- a/scripts/config.sh
+++ b/scripts/config.sh
@@ -15,6 +15,8 @@ backupeveryXdays=15
 makeXcopies=2
 cdrecordopts="-v -dao" 
 cronstopstart="/etc/init.d/cron"
+cacheburnimg=0
+cacheburnimgdir="/tmp"
 
 # These are exported so lsbackups can have access to them
 export backupdbin="$datadir/backups.db"